#include <cstdio>

const int MAXN = 105;
int N, a[MAXN], f[MAXN][MAXN][2];

int solve(int l, int r, bool parity) { // Memoization
	if (f[l][r][parity] >= 0)
		return f[l][r][parity];
	if (l == r)
		return f[l][r][parity] = true;
	f[l][r][parity] = false;
	if (parity) {
		if (solve(l, r, !parity) == false)
			return f[l][r][parity] = true;
	}
	for (int i = l, oneIsInTheLeft = false; i <= r; ++i) {
		if ((i == l || a[i] > a[i - 1]) && (i == r || a[i] > a[i + 1])) { // Can remove number a[i]
			int t = oneIsInTheLeft ? r - i : i - l;
			int parity2 = parity ^ (t % 2);
			if (oneIsInTheLeft) {
				if (solve(l, i - 1, parity2) == false)
					return f[l][r][parity] = true;
			} else {
				if (solve(i + 1, r, parity2) == false)
					return f[l][r][parity] = true;
			}
		}
		if (a[i] == 1)
			oneIsInTheLeft = true;
	}
	return f[l][r][parity] = false;
}

int main() {
	int T;
	scanf("%d", &T);
	while (T--) {
		scanf("%d", &N);
		for (int i = 1; i <= N; ++i)
			scanf("%d", &a[i]);
		for (int i = 1; i <= N; ++i) {
			for (int j = 1; j <= N; ++j) {
				f[i][j][0] = f[i][j][1] = -1;
			}
		}
		printf("%s\n", solve(1, N, 0) ? "Alice" : "Bob");
	}
	return 0;
}
