#include <cstdio>
#include <cmath>
#include <string>
#include <map>
using namespace std;

const int MAXP = 65, MAXL = 55;
int P, W, Q;
struct Planet {
	int x, y, z;
}p[MAXP];
char str[MAXL], str2[MAXL];
map<string, int> id;
double d[MAXP][MAXP];

double sqr(double x) {
	return x * x;
}

void Floyd() {
	for (int k = 0; k < P; ++k) {
		for (int i = 0; i < P; ++i) {
			for (int j = 0; j < P; ++j) {
				if (d[i][j] > d[i][k] + d[k][j])
					d[i][j] = d[i][k] + d[k][j];
			}
		}
	}
}

int main() {
	int T;
	scanf("%d", &T);
	for (int t = 1; t <= T; ++t) {
		scanf("%d", &P);
		id.clear();
		for (int i = 0; i < P; ++i) {
			scanf(" %s%d%d%d", str, &p[i].x, &p[i].y, &p[i].z);
			id[string(str)] = i;
		}
		scanf("%d", &W);
		for (int i = 0; i < P; ++i) {
			for (int j = 0; j < P; ++j) {
				d[i][j] = sqrt(sqr(p[i].x - p[j].x) + sqr(p[i].y - p[j].y) + sqr(p[i].z - p[j].z));
			}
		}
		for (int i = 0; i < W; ++i) {
			scanf(" %s %s", str, str2);
			d[id[str]][id[str2]] = 0;
		}
		Floyd();
		scanf("%d", &Q);
		printf("Case %d:\n", t);
		for (int i = 1; i <= Q; ++i) {
			scanf(" %s %s", str, str2);
			printf("The distance from %s to %s is %d parsecs.\n", str, str2, (int)(d[id[str]][id[str2]] + 0.5));
		}
	}
	return 0;
}
